# On crée une classe "piles" pour utiliser la structure abstraite de pile 
# sans s'occuper des détails. 

class Pile:
    # Variables (non accessibles) : 
    # liste   = liste des éléments constituant la pile
    # hauteur = nb d'éléments dans la pile
    # sommet  = dernier élément posé sur la pile
    
    # Méthodes : 
    # Pile()      : instancie l'objet "pile" en créant une pile vide
    # Pile(liste) : instancie l'objet "pile" en créant une pile qui contient 
    #               les éléments de la liste
    # getHeight(): donne la valeur de la hauteur
    # getTop() : donne la valeur du sommet
    # isVoid()   : retourne True ssi la pile est vide
    # push(x)  : pose x au sommet de la pile
    # pop()   : enlève et retourne l'élément au sommet de la pile

    def setVarPrivees(self):
        self.hauteur = len(self.liste)
        if (self.hauteur==0):
            self.sommet = None
        else:
            self.sommet = self.liste[-1]
    
    def __init__(self, valeurs):
        self.liste = valeurs
        self.setVarPrivees()
        
    def getHeight(self):
        return self.hauteur

    def getTop(self):
        return self.sommet
            
    def isVoid(self):
        return (self.hauteur==0)
    
    def push(self, x):
        self.liste.append(x)
        self.setVarPrivees()
        
    def pop(self):
        assert (self.hauteur>0), "Vous essayez de dépiler une pile vide"
        x = self.liste.pop()
        self.setVarPrivees()
        return x

    def str(self, s='.'):
        return s.join(str(x) for x in self.liste)
        
    def copy(self):
        return Pile(self.liste)
